<template>
  <div :class="classes">
    <div class="buttonContainer">
      <button
        class="btn btn-link"
        @click="cropComponent = true"
        :class="cropComponent ? 'active' : ''"
      >
        <i aria-hidden="true" class="fa fa-crop"></i> Crop Image</button
      ><button
        class="btn btn-link"
        @click="cropComponent = false"
        :class="!cropComponent ? 'active' : ''"
      >
        <i aria-hidden="true" class="fa fa-image"></i> Change Image
      </button>
    </div>
    <div v-show="cropComponent">
      <div
        style="
        display: flex;
        justify-content: space-around;
        margin: 12px;
        color: red;
        font-weight: 700;
      "
      >
        <p>Crop Image</p>
        <p>Preview</p>
      </div>

      <div class="modal-body">
        <br />
        <div class="img-cropper">
          <vue-cropper
            ref="cropper"
            :src="`https://cors-anywhere.herokuapp.com/${imgSrc}`"
            preview=".preview"
            style="width:400px;height:500px"
            :center="true"
            :viewMode="3"
            dragMode="move"
            crossOrigin
            :zoomable="false"
            :cropBoxResizable="true"
            :wheelZoomRatio="raitosize"
            :aspectRatio="ratioImage"
            @cropstart="changeCropImage"
          />
        </div>
        <!-- <clipper-basic
          class="my-clipper"
          ref="clipper"
          preview="preview"
          :src="imgSrc"
          :ratio="raitosize"
          round="true"
          @load="loadCb"
          v-model="checkfollow"
     
        /> -->
        <section class="preview-area">
          <div class="cropped-image">
            <img
              v-if="cropImage"
              :src="cropImage"
              alt="Cropped Image"
               style="width:400px;height:500px"
            />
            <!-- <clipper-preview
              class="my-clipper"
              name="preview"
              style="margin-left:100px"
            /> -->
          </div>
        </section>
      </div>

      <div class="popup_footer">
        <base-button
          class="btn btn-primary"
          role="button"
          @click.prevent="cropImages"
        >
          Crop
        </base-button>
        <base-button
          @click="$emit('on-close')"
          class="btn btn-default"
          role="button"
          >Close</base-button
        >
      </div>
    </div>
    <div v-show="!cropComponent"  
      style="width:100%;display:block;float:left;padding-bottom:20px"
    >
      <div class="container">
        <div class="row">
          <div class="col-sm-6">
            <div id="popup1" class="overlay" style="width: 400px">
              <div class="mb-3">
                <label
                  for="exampleFormControlInput1"
                  class="form-label"
                  style="padding-top:10px"
                  >Change Image</label
                >
                <input
                  class="form-control"
                  id="exampleFormControlInput1"
                  placeholder="Change Url Image"
                  v-model="urlchange"
                  @change="changeinput"
                />
              </div>
              <img
                :src="imgSrc"
                alt="Cropped Image"
                style="margin-top:20px;width:400px;height:500px"
              />
            </div>
          </div>
          <div v-if="demoImageChange" class="col-sm-6">
            <div id="popup1" class="overlay" style="width: 400px">
              <div class="mb-3">
                <label
                  for="exampleFormControlInput1"
                  class="form-label"
                  style="padding-top:10px"
                  >Image Demo</label
                >
              </div>
              <img
                :src="inputImageDemo"
                alt="Cropped Image"
                style="margin-top:50px;width:400px;height:500px"
              />
            </div>
          </div>
          <div class="col-sm-12 buttonchange" v-if="demoImageChange">
            <base-button
              class="btn btn-success "
              role="button"
              @click="addchangeimage"
            >
              Change Image
            </base-button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import VueCropper from "vue-cropperjs";
import { ModalBus } from "../eventBus";
import Advertisement from "../components/Advertisement";
import "cropperjs/dist/cropper.css";
import { clipperBasic, clipperPreview, clipperFixed } from "vuejs-clipper";
import Repository from "@/repositories/RepositoryFactory";
const riaServiceEnpoint = Repository.get("riaServiceEnpoint");
export default {
  props: {
    type: {
      type: String,
      value: "error" | "info" | "success" | "warning" | "texterea" | "html"
    },
    text: String,
    id: String,
    template: String,
    infor_hero_image: Object
  },
  data() {
    return {
      imgSrc: this.text.split("?")[0],
      cropImage: null,
      changeImage: false,
      urlchange: null,
      raitosize: 0.8,
      cropComponent: true,
      demoImageChange: false,
      inputImageDemo: null,
      check: null,
      checkfollow: null,
      newStyle: null
    };
  },
  created() {},
  mounted() {
    // this.setSizeImage();
  },
  watch: {
    imgSrc() {
      // this.setSizeImage();
    },
    check() {
      console.log("thay doi");
    }
  },
  components: {
    VueCropper
    // clipperBasic
    // clipperPreview
  },
  computed: {
    color() {
      switch (this.type) {
        case "error":
          return "red";
        case "success":
          return "teal";
        case "warning":
          return "orange";
        case "info":
        default:
          return "gray";
      }
    },
    classes() {
      const { color } = this;
      return [
        `bg-${color}-400 border border-${color}-200 text-black px-4 py-3 rounded-lg relative`
      ];
    },
    styleImage() {
      let height = this.infor_hero_image.hero_image_height;
      let width = this.infor_hero_image.hero_image_width;
      return `height:500px;width:${(500 / height) * width}px`;
    },
    ratioImage() {
      return 0.8;
    },
    urlImage() {
      let url = this.text;
      return url.split("?")[0];
    }
  },
  methods: {
    // get size box crop
    // setSizeImage() {
    //   setTimeout(() => {
    //     this.raitosize = this.$refs.clipper.imgRatio;
    //   }, 100);
    //   setTimeout(() => {
    //     this.$refs.clipper.setTL$.next({ bottom: 0, right: 0 });
    //     this.$refs.clipper.setWH$.next({ width: 100, height: 100 });
    //     this.check = this.$refs.clipper.zoomWH$.width;
    //   }, 200);
    // },
    // follow change input
    changeinput() {
      console.log(this.urlchange);
      if (this.urlchange != "") {
        this.demoImageChange = true;
        this.inputImageDemo = this.urlchange;
      } else {
        this.demoImageChange = false;
      }
    },
    //
    changeNewImage() {},
    addchangeimage() {
      this.$store.dispatch("ACTION_CROP_HERO_IMAGE_BY_ID", {
        id: this.id,
        hero_image: this.urlchange
      });
      this.urlchange = null;
      this.$emit("on-close");
    },
    changeCropImage() {
      let width =
        this.infor_hero_image.hero_image_width -
        2 * this.$refs.cropper.getData().x;
      let height =
        this.infor_hero_image.hero_image_height -
        2 * this.$refs.cropper.getData().y;
      this.newStyle = `height:500px;width:${(500 / height) * width}px`;
      this.cropImage = this.$refs.cropper.getCroppedCanvas().toDataURL();
    },
    async cropImages() {
      // get image data for post processing, e.g. upload or setting image src
      // const canvas = this.$refs.clipper.getDrawPos();
      // console.log(this.$refs.clipper.imgRatio);
      // this.cropImage = canvas.toDataURL("image/jpeg");
      // this.cropImage =
      //   this.imgSrc +
      //   `?v=1&width=${canvas.pos.dheight}&height=${canvas.pos.dwidth}&crop&auto=format&fm=webp&q=80`;
      this.$store.dispatch("ACTION_CROP_HERO_IMAGE_BY_ID", {
        id: this.id,
        hero_image: this.cropImage
      });
      //  this.cropImg = this.$refs.cropper.getCroppedCanvas().toDataURL();
      console.log(this.$refs.cropper.getData());
      let crop_detail_image = this.$refs.cropper.getData();
      let list_crop = {};
      list_crop.hero_image = {
        image_url: this.imgSrc,
        width: 400,
        height: 500,
        crop_status: "True",
        box: [
          crop_detail_image.x,
          crop_detail_image.y,
          crop_detail_image.width,
          crop_detail_image.height
        ]
      };

      let cropHeroImage = await riaServiceEnpoint.CropImage(list_crop);
      if (cropHeroImage) {
        let hero_image = cropHeroImage.data.hero_image.image_url_out;
        this.cropImage = hero_image;
        this.$store.dispatch("ACTION_CROP_IMAGE_FROM_USER", {
          id: this.id,
          hero_image
        });
      }
      // this.$emit("on-close");
    }
  }
};
</script>

<style scoped>
.img-cropper {
  width: 50%;
}
.preview-area {
  width: 50%;
}
.img-cropper div {
  margin: 0 auto;
}
.buttonContainer {
  background: rgba(87, 135, 164, 0.05);
  border: 0.5px dashed #5787a4;
  box-sizing: border-box;
  border-radius: 4px;
  width: 90%;
  margin: auto;
  padding: 10px;
  display: flex;
  justify-content: space-around;
}
.popup h2 {
  margin-top: 0;
  color: #333;
  font-family: Tahoma, Arial, sans-serif;
}
.popup .close {
  position: absolute;
  top: 20px;
  right: 30px;
  transition: all 200ms;
  font-size: 30px;
  font-weight: bold;
  text-decoration: none;
  color: #333;
}
.popup .close:hover {
  color: #06d85f;
}
.popup .content {
  max-height: 30%;
  overflow: auto;
}

@media screen and (max-width: 700px) {
  .box {
    width: 70%;
  }
  .popup {
    width: 70%;
  }
}
.modal-body {
  display: flex;
}
.popup_content {
  font-size: 15px;
  padding-bottom: 1em;
}
.popup_footer {
  padding: 1em 0;
  text-align: center;
}
.popup_footer button {
  display: inline-block;
  margin: 0 0.5em;
}
.my-clipper {
  width: 100%;
  max-width: 500px;
}
button.btn.btn-link.active {
  border: 1px solid #0cb9ed;
  padding: 10px;
  border-radius: 7px;
  box-shadow: 0 8px 6px -6px #726e6e;
}
.col-sm-12.buttonchange {
  text-align: -webkit-center;
  padding: 13px;
}
</style>
<style scoped>
.modal-dialog {
  width: 50% !important;
}
</style>